unit dpShare;

// Copyright  2001 by Ziff Davis Media, Inc.
// Written by Neil J. Rubenking

interface
uses Windows, SysUtils, Classes;

// This unit defines a handful of constants, variables, & structures
// that are used by several other units in the program.

const
  uttermax  = 20;
  fmtZoom   = 'Zoom (%d%%)|Zoom from 50%% to 400%% (%0:d%%)';
  fmtRotate = 'Rotate (%d)|Rotate the chart 0 to 360 degrees (%0:d)';

VAR
  Halting : Boolean;
  ininame : String;
type
  TChartExtra = record
    dSec     : String;      // Section title in INI file
    dTitle   : String;      // Full title (may be mashed for display)
    dImage   : String;      // image filename
    dCols    : TStringList; // list of colors
    dList    : TStringList; // full list of slices (may show fewer)
    dFilList : TStringList; // largest-file list
    dRgn     : HRgn;        // region defining top of 3D pie
    dBak     : Integer;     // background style
    dCircled : Boolean;     // true if pie is forced to a circle
    dLabels  : Boolean;     // true if labels should be displayed
    dElev    : Integer;     // pie 3D elevation
    dSlices  : Integer;     // number of slices
    dScroll  : Boolean;     // use scrollbars?
  end;

implementation

end.
