unit sizlistu;

interface
USES Windows, SysUtils, Classes;

type
TSizList = class(TObject)
private
  fList : TStringList;
  fMax : Integer;
    function GetIName(Index: Integer): String;
    function GetCount: Integer;
    function GetISize(Index: Integer): Int64;
protected

public
  constructor Create(vMax : Integer);
  destructor Destroy; override;
  function Add(const S : String; Siz : Int64) : Boolean;
  procedure AddList(SL : TSizList);
  procedure Clear;
  property IName[Index : Integer] : String read GetIName;
  property ISize[Index : Integer] : Int64 read GetISize;
  property Count : Integer read GetCount;
end;


implementation

{ TSizList }

function TSizList.Add(const S: String; Siz: Int64) : Boolean;
VAR NewS : String;
begin
  NewS := IntToHex(Siz, 16) + S;
  Result := False;
  IF (fList.Count > 0) AND (NewS < fList[0]) THEN
    Exit;
  Result := True;
  fList.Add(NewS);
  IF fList.Count > fMax THEN
    fList.Delete(0);
end;

procedure TSizList.AddList(SL: TSizList);
VAR N : Integer;
begin
  FOR N := 0 TO SL.Count-1 DO
    IF NOT Add(SL.IName[N], SL.ISize[N]) THEN
      Exit;
end;

procedure TSizList.Clear;
begin
  fList.Clear;
end;

constructor TSizList.Create(vmax : Integer);
begin
  fList := TStringList.Create;
  fList.Sorted := True;
  fMax := vMax;
end;

destructor TSizList.Destroy;
begin
  fList.Free;
  inherited;
end;

function TSizList.GetCount: Integer;
begin
  Result := fList.Count;
end;

function TSizList.GetIName(Index: Integer): String;
begin
  Result := fList[flist.Count-1-Index];
  System.Delete(Result, 1, 16);
end;

function TSizList.GetISize(Index: Integer): Int64;
begin
  Result := StrToInt64('$'+Copy(fList[flist.Count-1-Index], 1, 16));
end;

end.
